# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

from Game import GameState
import GridUtils

class TongaGameState(GameState):
    def successors(self):
        # drop own and opposing pices in adjacent cells
        for p1 in self.enumerate_coords_with_value(0):
            for p2, val in GridUtils.enumerate_neighbors(self.grid, p1):
                if val==0 and p1!=p2:
                    nextgrid = self.grid.copy()
                    nextgrid[p1] = self.current_player
                    nextgrid[p2] = self.next_player()
                    yield ((p1,p2), self.next_state_with_grid(nextgrid))
                    
    def player_score(self, pnum):
        # sum of squares of lengths of largest 3 groups
        groups = sorted(GridUtils.connected_groups(self.grid, pnum), key=len, reverse=True)
        return sum(len(g)*len(g) for g in groups[:3])                
                    
